"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _reactSyntaxHighlighter = _interopRequireDefault(require("react-syntax-highlighter"));

var Scroller = _interopRequireWildcard(require("./scroller"));

var _glamor = require("glamor");

var _stepParser = _interopRequireDefault(require("./step-parser"));

var _propTypes = _interopRequireDefault(require("prop-types"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

var selectedRules = (0, _glamor.css)({
  opacity: 1,
  transition: "opacity 300ms"
});
var unselectedRules = (0, _glamor.css)({
  opacity: 0.3,
  transition: "opacity 300ms"
});

var CodeSurfer = function CodeSurfer(_ref) {
  var code = _ref.code,
      step = _ref.step,
      lang = _ref.lang,
      showNumbers = _ref.showNumbers,
      dark = _ref.dark,
      monospace = _ref.monospace;
  var selectedTokens = new _stepParser["default"](step);
  return _react["default"].createElement(_reactSyntaxHighlighter["default"], {
    code: code,
    language: lang || "jsx",
    style: dark
  }, function (_ref2) {
    var className = _ref2.className,
        style = _ref2.style,
        tokens = _ref2.tokens,
        getLineProps = _ref2.getLineProps,
        getTokenProps = _ref2.getTokenProps;
    return _react["default"].createElement(Scroller.Container, {
      type: "pre",
      className: className,
      style: Object.assign({}, style, {
        background: null,
        fontFamily: monospace
      })
    }, _react["default"].createElement(Scroller.Content, {
      type: "code",
      style: {
        fontFamily: monospace
      }
    }, tokens.map(function (line, i) {
      return _react["default"].createElement("div", getLineProps({
        line: line,
        key: i
      }), showNumbers && _react["default"].createElement("span", {
        className: "token comment " + (selectedTokens.isLineSelected(i) ? selectedRules : unselectedRules),
        style: {
          userSelect: "none"
        }
      }, (i + 1 + ".").padStart(3), " "), line.map(function (token, key) {
        return _react["default"].createElement(Scroller.Element, _extends({
          type: "span"
        }, getTokenProps({
          token: token,
          key: key,
          selected: selectedTokens.isTokenSelected(i, key),
          className: selectedTokens.isTokenSelected(i, key) ? selectedRules : unselectedRules
        })));
      }));
    })));
  });
};

CodeSurfer.propTypes = {
  /** The code you want to show */
  code: _propTypes["default"].string.isRequired,

  /** The lines/tokens to highlight */
  step: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].shape({
    lines: _propTypes["default"].arrayOf(_propTypes["default"].number),
    range: _propTypes["default"].arrayOf(_propTypes["default"].number),
    ranges: _propTypes["default"].arrayOf(_propTypes["default"].arrayOf(_propTypes["default"].number)),
    tokens: _propTypes["default"].objectOf(_propTypes["default"].arrayOf(_propTypes["default"].number))
  })]),

  /** Any language supported in [prism-react-renderer](https://github.com/FormidableLabs/prism-react-renderer/blob/master/src/vendor/prism/includeLangs.js) */
  lang: _propTypes["default"].string,

  /** Whether to show line numbers or not */
  showNumbers: _propTypes["default"].bool,

  /** If you have a dark background set this prop to true (it will use the default dark theme) */
  dark: _propTypes["default"].bool,

  /** Use a theme from react-prism-renderer */
  theme: _propTypes["default"].object,

  /** Use your own font-family */
  monospace: _propTypes["default"].string
};
CodeSurfer.defaultProps = {
  lang: "jsx",
  step: {}
};
var _default = CodeSurfer;
exports["default"] = _default;