"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Element = exports.Content = exports.Container = void 0;

var _react = _interopRequireDefault(require("react"));

var _tween = _interopRequireDefault(require("./tween"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var getNewCenter = function getNewCenter(container, content, firstSelected, lastSelected) {
  var parentHeight = container.parentElement.offsetHeight;
  container.style.padding = "".concat(parentHeight / 2, "px 0");
  container.style.height = 0;
  firstSelected = firstSelected || content;
  lastSelected = lastSelected || firstSelected;
  var contentTop = content.offsetTop;
  var contentHeight = content.offsetHeight;
  var top = firstSelected.offsetTop;
  var bottom = lastSelected.offsetTop + lastSelected.offsetHeight;
  var selectedHeight = bottom - top;
  var middle = Math.floor((top + bottom) / 2);
  var containerHeight = container.offsetHeight;
  var scale = 1;

  if (selectedHeight > containerHeight) {
    scale = containerHeight / selectedHeight;
    var minScale = 0.2;
    scale = scale < minScale ? minScale : scale;
  } // center in the middle of the selected element


  var center = middle;
  var scaledContentHeight = contentHeight * scale;
  var scaledSelectedHeight = selectedHeight * scale;
  var contentMargin = (contentHeight - scaledContentHeight) / 2;
  var halfContent = contentHeight / 2;

  if (scale !== 1) {
    center = (middle - halfContent) * scale + halfContent;
  } // console.log("top", top);
  // console.log("bottom", bottom);
  // console.log("containerHeight", containerHeight);
  // console.log("selectedHeight", selectedHeight);
  // console.log("scaledSelectedHeight", scaledSelectedHeight);
  // console.log("contentHeight", contentHeight);
  // console.log("scaledContentHeight", scaledContentHeight);


  if (containerHeight >= scaledContentHeight) {
    // center in the middle of the content
    center = contentHeight / 2;
  } else if (containerHeight >= scaledSelectedHeight) {
    var minScroll = contentMargin + containerHeight / 2;
    var maxScroll = contentHeight - contentMargin - containerHeight / 2;
    center = center < minScroll ? minScroll : center;
    center = center > maxScroll ? maxScroll : center;
  } else {
    // console.log("Bigger selected than container");
    center = (top - halfContent) * scale + halfContent + containerHeight / 2;
  } // console.log(center);


  return {
    center: center,
    scale: scale
  };
};

var scrollTo = function scrollTo(container, content, center, scale, duration) {
  var startY = container.scrollTop;
  var containerScale = container.getBoundingClientRect().height / container.offsetHeight; // TODO browser support?

  var startScale = content.getBoundingClientRect().height / content.offsetHeight / containerScale;
  var endY = center;
  var step = {
    top: startY,
    scale: startScale
  };
  var shouldAnimate = true;
  var tween = new _tween["default"].Tween(step).to({
    top: endY,
    scale: scale
  }, duration).easing(_tween["default"].Easing.Circular.Out).onUpdate(function () {
    container.scrollTop = step.top | 0;
    content.style.transform = "scale(" + step.scale + ")";
  }).onComplete(function () {
    shouldAnimate = false;
  }).start();

  function animate(time) {
    if (!shouldAnimate) return;
    requestAnimationFrame(animate);

    _tween["default"].update(time);
  }

  requestAnimationFrame(animate);
};

var contentClassName = "scroll-content";
var selectedClassName = "scroll-selected";

var Container =
/*#__PURE__*/
function (_React$Component) {
  _inherits(Container, _React$Component);

  function Container(props) {
    var _this;

    _classCallCheck(this, Container);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Container).call(this, props));
    _this.containerRef = _react["default"].createRef();
    return _this;
  }

  _createClass(Container, [{
    key: "animate",
    value: function animate(duration) {
      var container = this.containerRef.current;
      var content = container.querySelector("." + contentClassName);
      var allSelected = container.querySelectorAll("." + selectedClassName);
      var firstSelected = allSelected.length ? allSelected[0] : content;
      var lastSelected = allSelected.length ? allSelected[allSelected.length - 1] : content;

      var _getNewCenter = getNewCenter(container, content, firstSelected, lastSelected),
          center = _getNewCenter.center,
          scale = _getNewCenter.scale;

      scrollTo(container, content, center, scale, duration);
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      this.animate(1);
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate() {
      this.animate(400);
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
          type = _this$props.type,
          height = _this$props.height,
          children = _this$props.children,
          style = _this$props.style,
          rest = _objectWithoutProperties(_this$props, ["type", "height", "children", "style"]);

      return _react["default"].createElement(type || "div", _objectSpread({
        ref: this.containerRef,
        style: Object.assign({}, {
          // height: 0,
          margin: 0,
          overflow: "hidden",
          textAlign: "center",
          position: "relative"
        }, style)
      }, rest), _react["default"].createElement("div", {
        style: {
          position: "relative"
        }
      }, children));
    }
  }]);

  return Container;
}(_react["default"].Component);

exports.Container = Container;

var Content =
/*#__PURE__*/
function (_React$Component2) {
  _inherits(Content, _React$Component2);

  function Content() {
    _classCallCheck(this, Content);

    return _possibleConstructorReturn(this, _getPrototypeOf(Content).apply(this, arguments));
  }

  _createClass(Content, [{
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
          type = _this$props2.type,
          children = _this$props2.children,
          style = _this$props2.style,
          className = _this$props2.className,
          rest = _objectWithoutProperties(_this$props2, ["type", "children", "style", "className"]);

      return _react["default"].createElement(type || "div", _objectSpread({
        className: contentClassName + " " + className,
        style: Object.assign({}, {
          display: "inline-block",
          textAlign: "left",
          width: "100%"
        }, style)
      }, rest), children);
    }
  }]);

  return Content;
}(_react["default"].Component);

exports.Content = Content;

var Element =
/*#__PURE__*/
function (_React$Component3) {
  _inherits(Element, _React$Component3);

  function Element() {
    _classCallCheck(this, Element);

    return _possibleConstructorReturn(this, _getPrototypeOf(Element).apply(this, arguments));
  }

  _createClass(Element, [{
    key: "render",
    value: function render() {
      var _this$props3 = this.props,
          type = _this$props3.type,
          selected = _this$props3.selected,
          children = _this$props3.children,
          className = _this$props3.className,
          rest = _objectWithoutProperties(_this$props3, ["type", "selected", "children", "className"]);

      return _react["default"].createElement(type || "div", _objectSpread({
        className: selected ? selectedClassName + " " + className : className
      }, rest), children);
    }
  }]);

  return Element;
}(_react["default"].Component);

exports.Element = Element;